import type { NextApiHandler } from 'next';
import { AddMiddleware, InternalMiddlewareMap, NextApiHandlerWithMiddleware, RouterMethod, TypedObject } from './type';
export declare abstract class ExpressLikeRouter {
    protected readonly middlewareParallelListMap: InternalMiddlewareMap;
    protected readonly middlewareQueueMap: InternalMiddlewareMap;
    protected readonly routeHandlerMap: Partial<Record<RouterMethod, NextApiHandlerWithMiddleware<unknown, any>>>;
    readonly use: AddMiddleware<ExpressLikeRouter>;
    readonly inject: AddMiddleware<ExpressLikeRouter>;
    readonly get: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly head: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly patch: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly options: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly connect: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly delete: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly trace: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly post: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly put: <T, M extends TypedObject<unknown> = TypedObject<unknown>>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    abstract build(): NextApiHandler;
    private addMiddleware;
    private addOrSetPartialArrayMap;
    private addRouterMethod;
}
